<?php
// Autor (c) Miroslav Novak, www.platiti.cz
// Pouzivani bez souhlasu autora neni povoleno
// #Ver:PRV098-49-ga9cb64a5:2022-11-14#

defined('_JEXEC') or die();

require_once(JPATH_ROOT . "/UniModul/UniModul.php");

class UniAdapter extends PaymentRoot {

	function __construct($uniModulName = null, $subMethod = null) {
		BeginUniErr();
		$this->uniModulName = $uniModulName;
		$this->subMethod = $subMethod;
		EndUniErr();
	}



	public function showAdminFormParams($params)
	{
		try {
			BeginUniErr();
			?>
				<div class="col100">
					<fieldset class="adminform">
						<table class="admintable" width="100%">
			<?php
			$uniFact = new UniModulFactory();
			$this->configInfo = $uniFact->getConfigInfo($this->uniModulName, $this->getLanguage(), $this->subMethod);
			foreach ($this->configInfo->configFields as $configField) {
				if (in_array($configField->type, array(ConfigFieldType::$text, ConfigFieldType::$choice))){
					$fldname = $this->getShortConfigName($configField->name);
					$value = isset($params[$fldname]) ? $params[$fldname] : '';
					echo "<tr><td class='key'>".$configField->label."</td><td>";
					if ($configField->type == ConfigFieldType::$text) {
						echo '<input type="text"  class="inputbox" size="100" name="pm_params['.$fldname.']" value="'.$value.'" />';
					} else if ($configField->type == ConfigFieldType::$choice) {
						echo '<select class="inputbox" name = "pm_params['.$fldname.']">';
						foreach ($configField->choiceItems as $val=>$lab) {
							echo '<option value="'.$val.'" '.(($val !== null && $val == $value)?' selected="selected"':'').'> '.$lab. '</option>\n';
						}
						echo '</select>';
					}
					echo "</td></tr>";
				}
			}

			$orders = JSFactory::getModel('orders', 'JshoppingModel'); //admin model
			?>
							<tr>
								<td class="key">
									<?php echo _JSHOP_TRANSACTION_END;?>
								</td>
								<td>
									<?php
									print JHTML::_('select.genericlist', $orders->getAllOrderStatus(), 'pm_params[transaction_end_status]', 'class = "inputbox" size = "1"', 'status_id', 'name', isset($params['transaction_end_status']) ? $params['transaction_end_status'] : '');
									echo " ".JHTML::tooltip(_JSHOP_PAYPAL_TRANSACTION_END_DESCRIPTION);
									?>
								</td>
							</tr>
							<tr>
								<td class="key">
									<?php echo _JSHOP_TRANSACTION_FAILED;?>
								</td>
								<td>
									<?php
									echo JHTML::_('select.genericlist',$orders->getAllOrderStatus(), 'pm_params[transaction_failed_status]', 'class = "inputbox" size = "1"', 'status_id', 'name', isset($params['transaction_failed_status']) ? $params['transaction_failed_status'] : '');
									echo " ".JHTML::tooltip(_JSHOP_PAYPAL_TRANSACTION_FAILED_DESCRIPTION);
									?>
								</td>
							</tr>
						</table>
					</fieldset>
				</div>
				<div class="clr"/>
			<?php
			EndUniErr();
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	protected function getShortConfigName($name) {
		$uniModulName = $this->uniModulName;
		$nn = $uniModulName . "B" . "_" . $name;
		return $nn;
	}


    function showPaymentForm($params, $pmconfigs){
		?>
			<script type="text/javascript">
			function check_pm_mytest(){
				jQuery('#payment_form').submit();
			}
			</script>
		<?php
    }

	function showEndForm($pmconfigs, $order) {
		try {
			BeginUniErr();
			$orderToPayInfo = $this->getOrderToPayInfo($pmconfigs, $order);
			$uniModul = $this->createUniModul($pmconfigs);
			$redirectAction = $uniModul->gatewayOrderRedirectAction($orderToPayInfo);
			if ($redirectAction->redirectUrl != null) {
				$app = JFactory::getApplication ();
				$uer = ResetUniErr();
				$app->redirect($redirectAction->redirectUrl);
				ResetUniErr($uer);
			} else if ($redirectAction->redirectForm != null) {
				$uniModul->formRedirect($redirectAction->redirectForm);
			}
			EndUniErr();
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	function getUrlParams($pmconfigs){
		try {
			BeginUniErr();
			$uniModul = $this->createUniModul($pmconfigs);
			$orderReplyStatus = $uniModul->gatewayReceiveReply($this->getLanguage());
			$this->orderReplyStatus = $orderReplyStatus;
			$params = array();
			$params['order_id'] = $orderReplyStatus->shopPairingInfo;
			$params['hash'] = "";
			$params['checkHash'] = 0;
			$params['checkReturnParams'] = 1;
			return EndUniErr($params);
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	function checkTransaction($pmconfigs, $order, $act){
		try {
			BeginUniErr();
			$orderReplyStatus = $this->orderReplyStatus;
			switch ($orderReplyStatus->orderStatus) {
				case OrderStatus::$successful:
					$newState = 1;
					break;
				case OrderStatus::$pending:
					$newState = 2;
					break;
				case OrderStatus::$failedRetriable;  //vzdy se vytvari novy order, takze zadne retry
				case OrderStatus::$failedFinal:
					$newState = 3;
					break;
				case OrderStatus::$invalidReply;
					$newState = null;
					break;
				default:
					user_error('neznamy status: '.$orderReplyStatus->orderStatus);
			}
			return EndUniErr(array($newState, $orderReplyStatus->resultText, $orderReplyStatus->gwOrderNumber));
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}


	protected function createUniModul($pmconfigs) {
		$uniFact = new UniModulFactory();
		$this->configInfo = $uniFact->getConfigInfo($this->uniModulName, $this->getLanguage(), $this->subMethod);
		$configSetting = $this->getConfigData($pmconfigs, $this->configInfo, $this->uniModulName, $this->subMethod);
		$this->configSetting = $configSetting;
		return $uniFact->createUniModul($this->uniModulName, $configSetting, $this->subMethod);
	}

	protected function getConfigData($pmconfigs, $configInfo, $uniModulName, $subMethod) {
		foreach ($this->configInfo->configFields as $configField) {
			if (in_array($configField->type, array(ConfigFieldType::$text, ConfigFieldType::$choice))) {
				$configData[$configField->name] = $pmconfigs[$this->getShortConfigName($configField->name)];
			} else {
				$configData[$configField->name] = null;
			}
		}

		$uniModulConfig = new UniModulConfig();
		$jcfg	= JFactory::getConfig();
		$dbtype = $jcfg->get('dbtype');
		$uniModulConfig->mysql_server = $jcfg->get('host');
		$uniModulConfig->mysql_dbname = $jcfg->get('db');
		$uniModulConfig->mysql_login = $jcfg->get('user');
		$uniModulConfig->mysql_password = $jcfg->get('password');
		$uniModulConfig->uniModulDirUrl = JROUTE::_ (JURI::root () . 'UniModul/');

		if ($dbtype != 'mysql' && $dbtype != 'mysqli') user_error('Eshop pouziva jinou nez mysql databazi');

		$uniModulConfig->adapterName = 'JoomShopping';
		$cfgs = create_initialize_object('ConfigSetting', array('configData'=>$configData, 'uniModulConfig'=>$uniModulConfig));
		//var_dump($cfgs, $pmconfigs); ob_flush(); flush(); uuui();
		return $cfgs;
	}


	protected function getOrderToPayInfo($pmconfigs, $order) {
		$orderToPayInfo = new OrderToPayInfo();
		$orderToPayInfo->shopOrderNumber = $order->order_id;
		$orderToPayInfo->shopPairingInfo = $order->order_id;
		$orderToPayInfo->amount = $order->order_total;
		$orderToPayInfo->currency = $order->currency_code_iso;
		$orderToPayInfo->language = $this->getLanguage();
		$orderToPayInfo->description = ''; // TODO: nazev eshopu

		$uri = JURI::getInstance();
		$liveurlhost = $uri->toString(array("scheme",'host', 'port'));
        $pm_method = $this->getPmMethod();
        $orderToPayInfo->replyUrl = $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=return&js_paymentclass=".$pm_method->payment_class);

		$customerData = new CustomerData();
		$customerData->email = $order->email;
		$customerData->first_name = $order->d_f_name;
		$customerData->last_name = $order->d_l_name;
		$customerData->street = $order->d_street;
		$customerData->city = $order->d_city;
		$customerData->post_code = $order->d_zip;
		$customerData->state = $order->d_state;
		$customerData->phone = $order->d_phone;

		$_country = JSFactory::getTable('country', 'jshop');
        $_country->load($order->d_country);
        $customerData->country = $_country->country_code_2;

		$orderToPayInfo->customerData = $customerData;
		return $orderToPayInfo;
	}

	protected function getLanguage() {
		$lang = JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		return $locale;
	}

}
